> ## Documentation Index
> Fetch the complete documentation index at: https://docs.threetone.in/llms.txt
> Use this file to discover all available pages before exploring further.

# Get Tool Executions

> Get paginated list of tool executions for a specific tool.



## OpenAPI

````yaml /api-reference/openapi.json get /v1/convai/tools/{tool_id}/executions
openapi: 3.1.0
info:
  title: Threetone API Documentation
  description: >-
    This is the documentation for the Threetone API. You can use this API to use
    our service programmatically with API keys sent in the x-api-key header. You
    can create and manage API keys in the dashboard at
    https://threetone.in/app/developers/api-keys.
  version: '1.0'
servers:
  - url: https://api.threetone.in
    description: Production
security: []
paths:
  /v1/convai/tools/{tool_id}/executions:
    get:
      tags:
        - Agents Platform
      summary: Get Tool Executions
      description: Get paginated list of tool executions for a specific tool.
      operationId: get_tool_executions_route
      parameters:
        - name: tool_id
          in: path
          required: true
          schema:
            type: string
            description: ID of the requested tool.
            title: Tool Id
          description: ID of the requested tool.
        - name: cursor
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Used for fetching next page. Cursor is returned in the response.
            title: Cursor
          description: Used for fetching next page. Cursor is returned in the response.
        - name: page_size
          in: query
          required: false
          schema:
            type: integer
            maximum: 100
            minimum: 1
            description: >-
              How many documents to return at maximum. Can not exceed 100,
              defaults to 30.
            default: 30
            title: Page Size
          description: >-
            How many documents to return at maximum. Can not exceed 100,
            defaults to 30.
        - name: is_error
          in: query
          required: false
          schema:
            anyOf:
              - type: boolean
              - type: 'null'
            description: Filter by error status. If not provided, returns all executions.
            title: Is Error
          description: Filter by error status. If not provided, returns all executions.
        - name: agent_id
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Filter by agent ID.
            title: Agent Id
          description: Filter by agent ID.
        - name: branch_id
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: Filter by agent branch ID.
            title: Branch Id
          description: Filter by agent branch ID.
        - name: start_time
          in: query
          required: false
          schema:
            anyOf:
              - type: number
              - type: 'null'
            description: Filter executions from this Unix timestamp (inclusive).
            title: Start Time
          description: Filter executions from this Unix timestamp (inclusive).
        - name: end_time
          in: query
          required: false
          schema:
            anyOf:
              - type: number
              - type: 'null'
            description: Filter executions until this Unix timestamp (inclusive).
            title: End Time
          description: Filter executions until this Unix timestamp (inclusive).
        - name: x-api-key
          in: header
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: >-
              Your API key for programmatic access. Send it in the x-api-key
              header; you can create and manage keys from the Developers page.
            title: X-Api-Key
          description: >-
            Your API key for programmatic access. Send it in the x-api-key
            header; you can create and manage keys from the Developers page.
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GetToolExecutionsPageResponseModel'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
components:
  schemas:
    GetToolExecutionsPageResponseModel:
      properties:
        executions:
          items:
            $ref: '#/components/schemas/ToolExecutionResponseModel'
          type: array
          title: Executions
        next_cursor:
          anyOf:
            - type: string
            - type: 'null'
          title: Next Cursor
        has_more:
          type: boolean
          title: Has More
      type: object
      required:
        - executions
        - has_more
      title: GetToolExecutionsPageResponseModel
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ToolExecutionResponseModel:
      properties:
        tool_id:
          type: string
          title: Tool Id
          description: The ID of the tool that was executed
        tool_request_id:
          type: string
          title: Tool Request Id
          description: The request/call ID associated with this tool execution
        conversation_id:
          type: string
          title: Conversation Id
          description: The ID of the conversation where the tool was executed
        agent_id:
          type: string
          title: Agent Id
          description: The ID of the agent that ran the tool
        branch_id:
          anyOf:
            - type: string
            - type: 'null'
          title: Branch Id
          description: The branch ID if the agent has branches
        timestamp:
          type: number
          title: Timestamp
          description: Unix timestamp when the tool was executed
        latency_secs:
          type: number
          title: Latency Secs
          description: How long the tool execution took
        is_error:
          type: boolean
          title: Is Error
          description: Whether the tool execution failed
          default: false
        request_payload:
          anyOf:
            - type: string
            - type: 'null'
          title: Request Payload
          description: LLM-extracted parameters sent to the tool (JSON string)
        response_payload:
          anyOf:
            - type: string
            - type: 'null'
          title: Response Payload
          description: Response returned by the tool
        error_message:
          anyOf:
            - type: string
            - type: 'null'
          title: Error Message
          description: Error message if the tool execution failed
        error_type:
          anyOf:
            - type: string
            - type: 'null'
          title: Error Type
          description: >-
            Error category (internal, customer_config, customer_auth,
            external_server, external_client, client_timeout, unknown)
        id:
          type: string
          title: Id
        tool_call_details:
          anyOf:
            - oneOf:
                - $ref: >-
                    #/components/schemas/ConversationHistoryTranscriptToolCallWebhookDetails
                - $ref: >-
                    #/components/schemas/ConversationHistoryTranscriptToolCallClientDetails
                - $ref: >-
                    #/components/schemas/ConversationHistoryTranscriptToolCallMCPDetails
                - $ref: >-
                    #/components/schemas/ConversationHistoryTranscriptToolCallApiIntegrationWebhookDetails-Output
              discriminator:
                propertyName: type
                mapping:
                  api_integration_webhook:
                    $ref: >-
                      #/components/schemas/ConversationHistoryTranscriptToolCallApiIntegrationWebhookDetails-Output
                  client:
                    $ref: >-
                      #/components/schemas/ConversationHistoryTranscriptToolCallClientDetails
                  mcp:
                    $ref: >-
                      #/components/schemas/ConversationHistoryTranscriptToolCallMCPDetails
                  webhook:
                    $ref: >-
                      #/components/schemas/ConversationHistoryTranscriptToolCallWebhookDetails
            - type: 'null'
          title: Tool Call Details
      type: object
      required:
        - tool_id
        - tool_request_id
        - conversation_id
        - agent_id
        - timestamp
        - latency_secs
        - id
      title: ToolExecutionResponseModel
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    ConversationHistoryTranscriptToolCallWebhookDetails:
      properties:
        type:
          type: string
          const: webhook
          title: Type
          default: webhook
        method:
          type: string
          title: Method
        url:
          type: string
          title: Url
        headers:
          additionalProperties:
            type: string
          type: object
          title: Headers
        path_params:
          additionalProperties:
            type: string
          type: object
          title: Path Params
        query_params:
          additionalProperties:
            type: string
          type: object
          title: Query Params
        body:
          anyOf:
            - type: string
            - type: 'null'
          title: Body
      type: object
      required:
        - method
        - url
      title: ConversationHistoryTranscriptToolCallWebhookDetails
    ConversationHistoryTranscriptToolCallClientDetails:
      properties:
        type:
          type: string
          const: client
          title: Type
          default: client
        parameters:
          type: string
          title: Parameters
      type: object
      required:
        - parameters
      title: ConversationHistoryTranscriptToolCallClientDetails
    ConversationHistoryTranscriptToolCallMCPDetails:
      properties:
        type:
          type: string
          const: mcp
          title: Type
          default: mcp
        mcp_server_id:
          type: string
          title: Mcp Server Id
        mcp_server_name:
          type: string
          title: Mcp Server Name
        integration_type:
          type: string
          title: Integration Type
        parameters:
          additionalProperties:
            type: string
          type: object
          title: Parameters
        approval_policy:
          type: string
          title: Approval Policy
        requires_approval:
          type: boolean
          title: Requires Approval
          default: false
        mcp_tool_name:
          type: string
          title: Mcp Tool Name
          default: ''
        mcp_tool_description:
          type: string
          title: Mcp Tool Description
          default: ''
      type: object
      required:
        - mcp_server_id
        - mcp_server_name
        - integration_type
        - approval_policy
      title: ConversationHistoryTranscriptToolCallMCPDetails
    ConversationHistoryTranscriptToolCallApiIntegrationWebhookDetails-Output:
      properties:
        type:
          type: string
          const: api_integration_webhook
          title: Type
          default: api_integration_webhook
        integration_id:
          type: string
          title: Integration Id
          default: ''
        credential_id:
          type: string
          title: Credential Id
          default: ''
        integration_connection_id:
          type: string
          title: Integration Connection Id
          default: ''
        webhook_details:
          $ref: >-
            #/components/schemas/ConversationHistoryTranscriptToolCallWebhookDetails
      type: object
      required:
        - type
        - integration_id
        - credential_id
        - integration_connection_id
        - webhook_details
      title: ConversationHistoryTranscriptToolCallApiIntegrationWebhookDetails

````